<template>
  <el-container>
    <el-main>
      <transition name="el-zoom-in-center">
        <el-row v-show="isShow" style="margin-bottom: 3%">
          <el-card style="background-color: #f2f6fc">
            <!-- Данные медиаплана -->
            <el-row
              :gutter="250"
              type="flex"
              justify="space-between"
              style="flex-wrap: wrap"
            >
              <InformationComponent :eventBus="eventBus" />
              <PlacementTypeComponent :eventBus="eventBus" />
              <ApplyComponent :eventBus="eventBus" />
            </el-row>
          </el-card>
        </el-row>
      </transition>
      <transition name="el-zoom-in-center">
        <!-- Параметры периодов -->
        <WeeksComponent v-show="isShow" :eventBus="eventBus" />
      </transition>
      <transition name="el-zoom-in-center">
        <el-row v-show="isShow">
          <el-card style="background-color: #f2f6fc">
            <!-- Новые временные параметры -->
            <NewTimesComponent v-show="isShow" :eventBus="eventBus" />
          </el-card>
        </el-row>
      </transition>
      <el-tooltip
        style="
          position: fixed;
          right: 10px;
          bottom: 30px;
          cursor: pointer;
          animation: float 6s ease-in-out infinite;
        "
        content="Начать тур по приложению"
        placement="top"
        effect="light"
      >
        <el-button @click="startTour()" size="large" icon="el-icon-info" />
      </el-tooltip>
    </el-main>
  </el-container>
</template>

<script lang="ts">
import { Component, Vue } from "vue-property-decorator";
import InformationComponent from "@/components/media-plan-parameters-view/InformationComponent.vue";
import WeeksComponent from "@/components/media-plan-parameters-view/WeeksComponent.vue";
import { AxiosInstance } from "@/modules/AxiosInstance";
import { MediaPlan } from "@/interfaces/MediaPlan";
import ApplyComponent from "@/components/media-plan-parameters-view/ApplyComponent.vue";
import { MediaPlanParameters } from "@/interfaces/parameters/MediaPlanParameters";
import {
  InterfaceMediaPlanParametersPeriod,
  MediaPlanParametersPeriod,
} from "@/interfaces/parameters/MediaPlanParametersPeriod";
import { MediaPlanParametersPeriodFilm } from "@/interfaces/parameters/MediaPlanParametersPeriodFilm";
import { AsyncRequestCatchException } from "@/decorators/AsyncExceptionCatch";
import NewTimesComponent from "@/components/media-plan-parameters-view/NewTimesComponent.vue";
import PlacementTypeComponent from "@/components/media-plan-parameters-view/PlacementTypeComponent.vue";
import Driver from "driver.js";

/**
 * Представление параметров медиаплана для автоматического размещения.
 */
@Component({
  components: {
    NewTimesComponent,
    ApplyComponent,
    WeeksComponent,
    InformationComponent,
    PlacementTypeComponent,
  },
})
export default class ViewMediaPlanParameters extends Vue {
  private inventoryNeed = 0;
  /**
   * @property {boolean} isShow - признак "отображать элемент".
   */
  private isShow = false;
  /**
   * @property {Vue|null} eventBus - автобус событий.
   */
  private eventBus: Vue | null = null;
  /**
   * @property {number|null} mediaPlanID - идентификатор медиаплана.
   */
  private mediaPlanID: number | null = null;
  /**
   * @property {MediaPlan|number} mediaPlan - медиаплан.
   */
  private mediaPlan: MediaPlan | null = null;
  // tourDriver
  private tourDriver: Driver = new Driver({
    allowClose: false,
    doneBtnText: "Завершить",
    closeBtnText: "Закрыть",
    nextBtnText: "Вперёд",
    prevBtnText: "Назад",
  });

  /**
   * @property {MediaPlanParameters} parameters - параметры автоматического размещения.
   */
  private parameters: MediaPlanParameters | null = null;

  /**
   * Метод вызывается после создания представления.
   */
  protected created(): void {
    // Если идентификатор не указан или указан неверно
    if (!this.$route.params.id || isNaN(parseInt(this.$route.params.id))) {
      // Оповещаем пользователя
      this.$notify({
        type: "error",
        title: "Ошибка пути",
        message:
          "Идентификатор медиаплана не указан или указан неверно! Вы будите перенаправлены на предыдущую страницу.",
      });

      // Переходим на предыдущую страницу
      setTimeout(() => {
        return this.$router.back();
      }, 3000);
    } else {
      // Создаём автобус событий
      this.eventBus = new Vue();
      // Вытаскиваем из URL ID медиаплана и сохраняем в переменную
      this.mediaPlanID = parseInt(this.$route.params.id);
      // Подписываемся на событие удаления параметров автоматического размещения медиаплана
      this.eventBus.$on(
        "delete-media-plan-parameters",
        this.onDeleteMediaPlanParameters
      );
    }
  }

  /**
   * Метод срабатывает после инициализации представления.
   */
  protected async mounted(): Promise<void> {
    // Вызываем метод запроса данных медиаплана
    await this.getMediaPlan();
    // Вызываем метод запроса параметров автоматической расстановки медиаплана
    await this.getMediaPlanParameters();

    // Отображаем элементы представления после небольшой задержки, чтобы воспроизвелась анимация
    setTimeout(() => (this.isShow = true), 200);

    // Настраиваем тур по приложению
    this.setupTourDriver();
  }

  /**
   * Метод вызывается перед уничтожением представления.
   */
  protected beforeDestroy(): void {
    // Отписываемся от события удаления параметров медиаплана
    this.eventBus?.$off(
      "delete-media-plan-parameters",
      this.onDeleteMediaPlanParameters
    );
    // Уничтожаем автобус событий
    this.eventBus?.$destroy();
  }

  /**
   * Метод настройки драйвера тура по приложению.
   */
  private setupTourDriver(): void {
    setTimeout(() => {
      this.tourDriver.defineSteps([
        {
          element: "#tour-info-component",
          popover: {
            title: "Компонент информации",
            description: "Тут отображается информация о текущем медиаплане.",
          },
        },
        {
          element: "#tour-algorithm-component",
          popover: {
            title: "Компонент алгоритмов",
            description:
              "В данном компоненте выбирается алгоритм расстановки роликов медиаплана. " +
              "На данный момент есть 2 основных алгоритма: равномерная расстановка и расстановка по аффинити. " +
              "При выборе алгоритма расстановка по аффинити требуется также выбрать целевую аудиторию.",
          },
        },
        {
          element: "#tour-parameters-component",
          popover: {
            title: "Компонент параметров периодов",
            position: "top",
            description:
              "Здесь указываются параметры (правила), " +
              "по которым программатик будет осуществлять расстановку роликов медиаплана.",
          },
        },
        {
          element: ".tour-date-picker-element",
          popover: {
            title: "Элемент периода",
            position: "Top",
            description:
              "В данном элементе указывается дата начала периода и " +
              "дата окончания периода расстановки роликов.",
          },
        },
        {
          element: ".tour-inventory-element",
          popover: {
            title: "Элемент инвентаря периода",
            position: "Top",
            description:
              "В этом эелементе указывается количество инвентаря, " +
              "который нужно набрать роликами в данном периоде.",
          },
        },
        {
          element: ".tour-prime-percent-element",
          popover: {
            title: "Элемент процента Prime инвентаря",
            position: "Top",
            description:
              "Тут указывается % prime от инвентаря периода. " +
              "Пример: если 60% prime - нужно указать значение 0.6",
          },
        },
        {
          element: "#tour-film-component-0",
          popover: {
            title: "Группа роликов инвентаря",
            position: "Top",
            description:
              "В данных элементах указывается % инвентаря ролика от инвентаря периода. " +
              "Установка значений в будет доступна только после выбора даты начала и окончания периода.",
          },
        },
        {
          element: "#tour-times-component",
          popover: {
            title: "Компоненты временных интервалов",
            position: "Top",
            description:
              "В этом компоненте выбираются часовые и получасовые интервалы, " +
              "для ограничения выбора рекламных блоков, входящих в эти временные интервалы.",
          },
        },
        {
          element: "#tour-apply-element",
          popover: {
            title: "Кнопка применения параметров",
            description:
              "Если вы добавили или изменили параметры - нажмите на эту кнопку, " +
              "чтобы программатик запомнил новые параметры.",
          },
        },
        {
          element: "#tour-delete-element",
          popover: {
            title: "Кнопка удаления параметров",
            description:
              "При нажатии на эту кнопку удаляться все параметры программатика и страница перезагрузиться.",
          },
        },
      ]);
    }, 1000);
  }

  @AsyncRequestCatchException
  private async getMediaPlan(): Promise<void> {
    // Отправляем запрос
    const response = await AxiosInstance.get(
      "media-plan-parameters/get-media-plan",
      {
        params: {
          mediaPlanID: this.mediaPlanID,
        },
      }
    );

    // Создаём обхект медиаплана
    this.mediaPlan = new MediaPlan(response.data);
    // Оповещаем подписчиков события о получении данных медиаплана
    this.eventBus?.$emit("media-plan-response", this.mediaPlan);
  }

  /**
   * Метод запроса параметров автоматической расстановки медиаплана.
   */
  @AsyncRequestCatchException
  private async getMediaPlanParameters(): Promise<void> {
    // Отправляем запрос
    const response = await AxiosInstance.get(
      "media-plan-parameters/get-parameters",
      {
        params: {
          mediaPlanID: this.mediaPlanID,
        },
      }
    );
    // Если есть данные - создаём объект и сохраняем в переменную
    if (!response.data) {
      const parameter = this.createMediaPlanParameters();
      if (!parameter) return;
      this.parameters = parameter;
    } else {
      this.parameters = new MediaPlanParameters(response.data);
      if (
        this.parameters.percentInventoryNeed == null ||
        this.parameters.percentInventoryNeed == 0
      ) {
        this.parameters.percentInventoryNeed = 99;
      } else {
        this.parameters.percentInventoryNeed =
          this.parameters.percentInventoryNeed * 100;
      }
      this.parameters.periods.forEach((period) => {
        period.percentPrime = period.percentPrime * 100;
        period.films.forEach(
          (film) => (film.inventoryPercent = film.inventoryPercent * 100)
        );
      });
      this.createMediaPlanParameters();
    }
    // Оповещаем подписчиков о получении параметров автоматической расстановки медиаплана
    this.eventBus?.$emit("media-plan-parameters-response", this.parameters);
  }

  /**
   * Метод создания параметров автоматической расстановки медиаплана.
   */
  private createMediaPlanParameters(): MediaPlanParameters | undefined {
    // Проверяем, есть ли данные о медиаплане, если нет - оповещаем пользователя
    if (!this.mediaPlan) {
      this.$notify({
        type: "error",
        title: "Внутренняя ошибка",
        message:
          "Невозможно создать параметры, из-за отсутсвия данных о медиаплане.",
      });
      return;
    }

    let length = 5;
    if (this.parameters !== null) {
      length -= this.parameters.periods.length;
      this.parameters.periods.forEach((period) => {
        const films = this.mediaPlan?.films
          .filter((mediaPlanFilm) => {
            return !period.films.some((parametersFilm) => {
              return mediaPlanFilm.linkID == parametersFilm.linkID;
            });
          })
          .map((link, index) => {
            return new MediaPlanParametersPeriodFilm({
              id: index,
              linkID: link.linkID,
              duration: link.duration,
              versionName: link.versionName,
              inventoryPercent: 0.0,
              dateFrom: link.dateFrom,
              dateBefore: link.dateBefore,
            });
          });
        if (films) {
          period.films.push(...films);
        }
      });
      this.parameters.periods.forEach((period) => {
        period.films.forEach((film) => {
          const link = this.mediaPlan?.films.find(
            (link) => link.linkID == film.linkID
          );
          if (link) {
            film.duration = link.duration;
            film.versionName = link.versionName;
          }
        });
      });
    }

    const periods = [];
    for (let i = 0; i < length; i++) {
      periods.push(
        new MediaPlanParametersPeriod({
          id: 0,
          fromDate: null,
          beforeDate: null,
          inventory: 0.0,
          percentPrime: 0.0,
          films: this.mediaPlan.films
            .sort((a, b) => b.duration - a.duration)
            .map((link, index) => {
              return new MediaPlanParametersPeriodFilm({
                id: index,
                linkID: link.linkID,
                duration: link.duration,
                versionName: link.versionName,
                inventoryPercent: this.mediaPlan?.films.length == 1 ? 1.0 : 0.0,
                dateFrom: link.dateFrom,
                dateBefore: link.dateBefore,
              });
            }),
        })
      );
    }

    if (this.parameters !== null) {
      this.parameters.periods.push(...periods);
      return;
    }

    // Создаём параметры автоматического размещения
    return new MediaPlanParameters({
      id: 0,
      mediaPlanID: this.mediaPlan.id,
      times: [],
      periods: periods as InterfaceMediaPlanParametersPeriod[],
      placement: null,
      audience: null,
      percentInventoryNeed: 99,
      isPlacementActive: false,
      isAssignedRatingsPlacement: true,
    });
  }

  /**
   * Метод удаления параметров автоматического размещения медиаплана.
   */
  @AsyncRequestCatchException
  private async onDeleteMediaPlanParameters(): Promise<void> {
    await AxiosInstance.get("media-plan-parameters/delete-parameters", {
      params: { mediaPlanID: this.mediaPlanID },
    });
    location.reload();
  }

  private startTour(): void {
    setTimeout(() => this.tourDriver.start(), 200);
  }
}
</script>

<style>
@keyframes float {
  0% {
    box-shadow: 0 5px 15px 0 rgba(0, 0, 0, 0.6);
    transform: translatey(0px);
  }
  50% {
    box-shadow: 0 25px 15px 0 rgba(0, 0, 0, 0.2);
    transform: translatey(-20px);
  }
  100% {
    box-shadow: 0 5px 15px 0 rgba(0, 0, 0, 0.6);
    transform: translatey(0px);
  }
}
</style>
